//
// AniamtionFinalView.swift
// Generated by Core Animator version 1.5.2 on 2/11/19.
//
// DO NOT MODIFY THIS FILE. IT IS AUTO-GENERATED AND WILL BE OVERWRITTEN
//

import UIKit

private class _AniamtionFinalPassthroughView: UIView {
    override func point(inside point: CGPoint, with event: UIEvent?) -> Bool {
        for subview in subviews as [UIView] {
            if subview.point(inside: convert(point, to: subview), with: event) { return true }
        }
        return false
    }
}

@IBDesignable
class AniamtionFinalView : UIView, CAAnimationDelegate {


	var animationCompletions = Dictionary<CAAnimation, (Bool) -> Void>()
	var viewsByName: [String : UIView]!

	// - MARK: Life Cycle

	convenience init() {
		self.init(frame: CGRect(x: 0, y: 0, width: 1500, height: 1500))
	}

	override init(frame: CGRect) {
		super.init(frame: frame)
		self.setupHierarchy()
	}

	required init?(coder aDecoder: NSCoder) {
		super.init(coder: aDecoder)
		self.setupHierarchy()
	}

	// - MARK: Scaling

	override func layoutSubviews() {
		super.layoutSubviews()

		if let scalingView = self.viewsByName["__scaling__"] {
			var xScale = self.bounds.size.width / scalingView.bounds.size.width
			var yScale = self.bounds.size.height / scalingView.bounds.size.height
			switch contentMode {
			case .scaleToFill:
				break
			case .scaleAspectFill:
				let scale = max(xScale, yScale)
				xScale = scale
				yScale = scale
			default:
				let scale = min(xScale, yScale)
				xScale = scale
				yScale = scale
			}
			scalingView.transform = CGAffineTransform(scaleX: xScale, y: yScale)
			scalingView.center = CGPoint(x:self.bounds.midX, y:self.bounds.midY)
		}
	}

	// - MARK: Setup

	func setupHierarchy() {
		var viewsByName: [String : UIView] = [:]
		let bundle = Bundle(for:type(of: self))
		let __scaling__ = UIView()
		__scaling__.bounds = CGRect(x:0, y:0, width:1500, height:1500)
		__scaling__.center = CGPoint(x:750.0, y:750.0)
		__scaling__.clipsToBounds = true
		__scaling__.backgroundColor = UIColor(red: 0.149, green: 0.621, blue: 0.733, alpha: 1.0)
		self.addSubview(__scaling__)
		viewsByName["__scaling__"] = __scaling__

		let roundedImageView__root = _AniamtionFinalPassthroughView()
		let roundedImageView__xScale = _AniamtionFinalPassthroughView()
		let roundedImageView__yScale = _AniamtionFinalPassthroughView()
		let roundedImageView = UIImageView()
		let imgRoundedImageView = UIImage(named:"artist.png", in: bundle, compatibleWith: nil)
		if imgRoundedImageView == nil {
			print("** Warning: Could not create image from 'RoundedImageView.png'")
		}
		roundedImageView.image = imgRoundedImageView
		roundedImageView.contentMode = .scaleAspectFill
		roundedImageView.bounds = CGRect(x:0, y:0, width:637.0, height:637.0)
        roundedImageView.layer.cornerRadius = roundedImageView.bounds.width / 2
        roundedImageView.layer.masksToBounds = true
		roundedImageView__root.layer.position = CGPoint(x:750.000, y:431.500)
		roundedImageView__root.alpha = 0.00
		roundedImageView__xScale.transform = CGAffineTransform(scaleX: 1.00, y: 1.00)
		roundedImageView__yScale.transform = CGAffineTransform(scaleX: 1.00, y: 1.00)
		roundedImageView__root.transform = CGAffineTransform(rotationAngle: 0.000)
		roundedImageView__root.addSubview(roundedImageView__xScale)
		roundedImageView__xScale.addSubview(roundedImageView__yScale)
		roundedImageView__yScale.addSubview(roundedImageView)
		__scaling__.addSubview(roundedImageView__root)
		viewsByName["RoundedImageView__root"] = roundedImageView__root
		viewsByName["RoundedImageView__xScale"] = roundedImageView__xScale
		viewsByName["RoundedImageView__yScale"] = roundedImageView__yScale
		viewsByName["RoundedImageView"] = roundedImageView

		let winner__root = _AniamtionFinalPassthroughView()
		let winner__xScale = _AniamtionFinalPassthroughView()
		let winner__yScale = _AniamtionFinalPassthroughView()
		let winner = UIImageView()
		let imgWinner = UIImage(named:"winner.png", in: bundle, compatibleWith: nil)
		if imgWinner == nil {
			print("** Warning: Could not create image from 'winner.png'")
		}
		winner.image = imgWinner
		winner.contentMode = .center
		winner.bounds = CGRect(x:0, y:0, width:604.0, height:302.0)
		winner__root.layer.position = CGPoint(x:750.000, y:750.000)
		winner__root.alpha = 0.00
		winner__xScale.transform = CGAffineTransform(scaleX: 1.00, y: 1.00)
		winner__yScale.transform = CGAffineTransform(scaleX: 1.00, y: 1.00)
		winner__root.transform = CGAffineTransform(rotationAngle: 0.000)
		winner__root.addSubview(winner__xScale)
		winner__xScale.addSubview(winner__yScale)
		winner__yScale.addSubview(winner)
		__scaling__.addSubview(winner__root)
		viewsByName["winner__root"] = winner__root
		viewsByName["winner__xScale"] = winner__xScale
		viewsByName["winner__yScale"] = winner__yScale
		viewsByName["winner"] = winner

		self.viewsByName = viewsByName
	}

	// - MARK: Bougi

    func addBougiAnimation(userImage:String,result:GameWinner) {
        addBougiAnimation(beginTime: 0, fillMode: CAMediaTimingFillMode.both.rawValue, removedOnCompletion: false, completion: nil,userImage:userImage,result:result)
	}
	func addBougiAnimation(userImage:String,result:GameWinner,completion: ((Bool) -> Void)?) {
        addBougiAnimation(beginTime: 0, fillMode: CAMediaTimingFillMode.both.rawValue, removedOnCompletion: false, completion: completion,userImage:userImage,result:result)
	}

	func addBougiAnimation(userImage:String,result:GameWinner,removedOnCompletion: Bool) {
        addBougiAnimation(beginTime: 0, fillMode: removedOnCompletion ? CAMediaTimingFillMode.removed.rawValue : CAMediaTimingFillMode.both.rawValue, removedOnCompletion: removedOnCompletion, completion: nil,userImage:userImage,result:result)
	}

	func addBougiAnimation(userImage:String,result:GameWinner,removedOnCompletion: Bool, completion: ((Bool) -> Void)?) {
        addBougiAnimation(beginTime: 0, fillMode: removedOnCompletion ? CAMediaTimingFillMode.removed.rawValue : CAMediaTimingFillMode.both.rawValue, removedOnCompletion: removedOnCompletion, completion: completion,userImage:userImage,result:result)
	}

	func addBougiAnimation(beginTime: CFTimeInterval, fillMode: String, removedOnCompletion: Bool, completion: ((Bool) -> Void)?,userImage:String,result:GameWinner) {
        (self.viewsByName["RoundedImageView"] as! UIImageView).setImage(with: URL(string: userImage), placeholder: nil, transformer: nil, progress: nil, completion: nil)
        switch result {
        case .draw:
            
            (self.viewsByName["winner"] as! UIImageView).image = UIImage(named: Localization("Draw"))
        case .masterLoser:
            (self.viewsByName["winner"] as! UIImageView).image = UIImage(named: Localization("loser"))
        case .masterWinner:
            (self.viewsByName["winner"] as! UIImageView).image = UIImage(named: Localization("winner"))
        
        }
        let linearTiming = CAMediaTimingFunction(name: CAMediaTimingFunctionName.linear)
		let overshootTiming = CAMediaTimingFunction(controlPoints: 0.00, 0.00, 0.58, 1.30)
		if let complete = completion {
			let representativeAnimation = CABasicAnimation(keyPath: "not.a.real.key")
			representativeAnimation.duration = 1.500
			representativeAnimation.delegate = self
			self.layer.add(representativeAnimation, forKey: "Bougi")
			self.animationCompletions[layer.animation(forKey: "Bougi")!] = complete
		}

		let roundedImageViewOpacityAnimation = CAKeyframeAnimation(keyPath: "opacity")
		roundedImageViewOpacityAnimation.duration = 1.500
		roundedImageViewOpacityAnimation.values = [0.000, 1.000, 1.000] as [Float]
		roundedImageViewOpacityAnimation.keyTimes = [0.000, 0.167, 1.000] as [NSNumber]
		roundedImageViewOpacityAnimation.timingFunctions = [linearTiming, linearTiming]
		roundedImageViewOpacityAnimation.beginTime = beginTime
        roundedImageViewOpacityAnimation.fillMode = CAMediaTimingFillMode(rawValue: fillMode)
		roundedImageViewOpacityAnimation.isRemovedOnCompletion = removedOnCompletion
       //added
        let orangeButtonScaleXAnimation = CAKeyframeAnimation(keyPath: "transform.scale.x")
        orangeButtonScaleXAnimation.duration = 0.500
        orangeButtonScaleXAnimation.values = [1.000, 1.600, 1.000] as [Float]
        orangeButtonScaleXAnimation.keyTimes = [0.000, 0.500, 1.000] as [NSNumber]
        orangeButtonScaleXAnimation.timingFunctions = [linearTiming, overshootTiming]
       // viewToAnimate.layer.add(orangeButtonScaleXAnimation, forKey:"grow_ScaleX")
        self.viewsByName["RoundedImageView__root"]?.layer.add(orangeButtonScaleXAnimation, forKey:"grow_ScaleX")
        let orangeButtonScaleYAnimation = CAKeyframeAnimation(keyPath: "transform.scale.y")
        orangeButtonScaleYAnimation.duration = 0.500
        orangeButtonScaleYAnimation.values = [1.000, 1.600, 1.000] as [Float]
        orangeButtonScaleYAnimation.keyTimes = [0.000, 0.500, 1.000] as [NSNumber]
        orangeButtonScaleYAnimation.timingFunctions = [linearTiming, overshootTiming]
        //viewToAnimate.layer.add(orangeButtonScaleYAnimation, forKey:"grow_ScaleY")
         self.viewsByName["RoundedImageView__root"]?.layer.add(orangeButtonScaleXAnimation, forKey:"grow_ScaleY")
        //fin added
        self.viewsByName["RoundedImageView__root"]?.layer.add(roundedImageViewOpacityAnimation, forKey:"Bougi_Opacity")

		let winnerOpacityAnimation = CAKeyframeAnimation(keyPath: "opacity")
		winnerOpacityAnimation.duration = 1.500
		winnerOpacityAnimation.values = [0.000, 0.000, 0.000, 0.000, 1.000] as [Float]
		winnerOpacityAnimation.keyTimes = [0.000, 0.167, 0.168, 0.367, 1.000] as [NSNumber]
		winnerOpacityAnimation.timingFunctions = [linearTiming, linearTiming, linearTiming, overshootTiming]
		winnerOpacityAnimation.beginTime = beginTime
        winnerOpacityAnimation.fillMode = CAMediaTimingFillMode(rawValue: fillMode)
		winnerOpacityAnimation.isRemovedOnCompletion = removedOnCompletion
		self.viewsByName["winner__root"]?.layer.add(winnerOpacityAnimation, forKey:"Bougi_Opacity")
	}

	func removeBougiAnimation() {
		self.layer.removeAnimation(forKey: "Bougi")
		self.viewsByName["RoundedImageView__root"]?.layer.removeAnimation(forKey: "Bougi_Opacity")
		self.viewsByName["winner__root"]?.layer.removeAnimation(forKey: "Bougi_Opacity")
	}

	// MARK: CAAnimationDelegate
	func animationDidStop(_ anim: CAAnimation, finished flag: Bool) {
		if let completion = self.animationCompletions[anim] {
			self.animationCompletions.removeValue(forKey: anim)
			completion(flag)
		}
	}

	func removeAllAnimations() {
		for subview in viewsByName.values {
			subview.layer.removeAllAnimations()
		}
		self.layer.removeAnimation(forKey: "Bougi")
	}
}
